module globals
	use myfuncs
	use dotops
	use dispmodule
    
    real                :: alpha=0.05, htarget=.1
    integer             :: k=20
    logical             :: quantileflag=.false.

	real, parameter		::xsimin=-0.50, xsimax=0.5
	real, parameter		::pfxsimin=-.5, pfxsimax=0.5
    
	real				:: lengthfudge=0.01
    integer, parameter  :: nalt=20, napp=60, nchk=200
    integer             :: nimp
    real, allocatable   :: impgrid(:)
    real                :: altgrid(nalt), appgrid(napp), chkgrid(nchk)
    real                :: walt0(nalt), walt(nalt)
	
	real				:: cvgenLR, rlgenLR
	real, allocatable	:: genLRstats(:)
    
	integer, parameter	:: nsim=50000
    real, allocatable   :: Zs(:,:), densaltraw(:,:), densapp(:,:), densaltz(:,:)
    real                :: densalt(nsim), ldensimp(nsim), lam(napp)

    real, parameter     :: quaderr=1E-4
    
    real, allocatable   :: globalz(:), globalxs(:)
    real                :: globalxsi, globalls, globalq
	real				:: globallf1
!$omp threadprivate(globalxsi,globalz,globalls,globalxs,globallf1,globalq)
	
    interface
		real function ext_f(s)
			real, intent(in)	:: s
        end function
        real function ext_minuslogf(s)
			real, intent(in)	:: s
        end function
        real function ext_minusdlogf(s)
			real, intent(in)	:: s
        end function
        real function ext_minuslogstat(s)
			real, intent(in)	:: s
		end function
        real function ext_pfeq(s)
			real, intent(in)	:: s
		end function
    end interface
	procedure(real), pointer	::  intfunc,dintfunc
!$omp threadprivate(intfunc,dintfunc)
   
    logical         :: printflag=.false.
	integer			:: globalc=0, gl
    
    
end module
